Index: popwin.c
===================================================================
--- popwin.c	(revision 0881cdda52baa4677179208b39a3392f06182cf5)
+++ popwin.c	(revision 05ca0d8685143d49b9e1c7d2949a55f6976c27ff)
@@ -4,6 +4,4 @@
 {
   pw->active=0;
-  pw->lines=0;
-  pw->cols=0;
   return(0);
 }
@@ -11,24 +9,47 @@
 int owl_popwin_up(owl_popwin *pw)
 {
-  int glines, gcols, startcol, startline;
-  WINDOW *popwin, *borderwin;
+  pw->border = owl_window_new(NULL);
+  pw->content = owl_window_new(pw->border);
+  g_signal_connect(pw->border, "redraw", G_CALLBACK(owl_popwin_draw_border), 0);
+  owl_signal_connect_object(owl_window_get_screen(), "resized", G_CALLBACK(owl_popwin_size_border), pw->border, 0);
+  owl_signal_connect_object(pw->border, "resized", G_CALLBACK(owl_popwin_size_content), pw->content, 0);
 
-  /* calculate the size of the popwin */
-  glines=owl_global_get_lines(&g);
-  gcols=owl_global_get_cols(&g);
+  /* bootstrap sizing */
+  owl_popwin_size_border(owl_window_get_screen(), pw->border);
 
-  pw->lines = owl_util_min(glines,24)*3/4 + owl_util_max(glines-24,0)/2;
-  startline = (glines-pw->lines)/2;
+  owl_window_show_all(pw->border);
 
-  pw->cols = owl_util_min(gcols,90)*15/16 + owl_util_max(gcols-90,0)/2;
-  startcol = (gcols-pw->cols)/2;
+  pw->active=1;
+  return(0);
+}
 
-  borderwin = newwin(pw->lines, pw->cols, startline, startcol);
-  pw->borderpanel = new_panel(borderwin);
-  popwin = newwin(pw->lines-2, pw->cols-2, startline+1, startcol+1);
-  pw->poppanel = new_panel(popwin);
+void owl_popwin_size_border(owl_window *parent, void *user_data)
+{
+  int lines, cols, startline, startcol;
+  int glines, gcols;
+  owl_window *border = user_data;
 
-  werase(popwin);
-  werase(borderwin);
+  owl_window_get_position(parent, &glines, &gcols, 0, 0);
+
+  lines = owl_util_min(glines,24)*3/4 + owl_util_max(glines-24,0)/2;
+  startline = (glines-lines)/2;
+  cols = owl_util_min(gcols,90)*15/16 + owl_util_max(gcols-90,0)/2;
+  startcol = (gcols-cols)/2;
+
+  owl_window_set_position(border, lines, cols, startline, startcol);
+}
+
+void owl_popwin_size_content(owl_window *parent, void *user_data)
+{
+  int lines, cols;
+  owl_window *content = user_data;
+  owl_window_get_position(parent, &lines, &cols, 0, 0);
+  owl_window_set_position(content, lines-2, cols-2, 1, 1);
+}
+
+void owl_popwin_draw_border(owl_window *w, WINDOW *borderwin, void *user_data)
+{
+  int lines, cols;
+  owl_window_get_position(w, &lines, &cols, 0, 0);
   if (owl_global_is_fancylines(&g)) {
     box(borderwin, 0, 0);
@@ -37,31 +58,22 @@
     wmove(borderwin, 0, 0);
     waddch(borderwin, '+');
-    wmove(borderwin, pw->lines-1, 0);
+    wmove(borderwin, lines-1, 0);
     waddch(borderwin, '+');
-    wmove(borderwin, pw->lines-1, pw->cols-1);
+    wmove(borderwin, lines-1, cols-1);
     waddch(borderwin, '+');
-    wmove(borderwin, 0, pw->cols-1);
+    wmove(borderwin, 0, cols-1);
     waddch(borderwin, '+');
   }
-    
-  owl_global_set_needrefresh(&g);
-  pw->active=1;
-  return(0);
 }
 
 int owl_popwin_close(owl_popwin *pw)
 {
-  WINDOW *popwin, *borderwin;
+  owl_window_unlink(pw->border);
+  g_object_unref(pw->border);
+  g_object_unref(pw->content);
 
-  popwin = panel_window(pw->poppanel);
-  borderwin = panel_window(pw->borderpanel);
-
-  del_panel(pw->poppanel);
-  del_panel(pw->borderpanel);
-  delwin(popwin);
-  delwin(borderwin);
-
+  pw->border = 0;
+  pw->content = 0;
   pw->active=0;
-  owl_global_set_needrefresh(&g);
   return(0);
 }
@@ -72,16 +84,6 @@
 }
 
-WINDOW *owl_popwin_get_curswin(const owl_popwin *pw)
+owl_window *owl_popwin_get_content(const owl_popwin *pw)
 {
-  return panel_window(pw->poppanel);
+  return pw->content;
 }
-
-int owl_popwin_get_lines(const owl_popwin *pw)
-{
-  return(pw->lines-2);
-}
-
-int owl_popwin_get_cols(const owl_popwin *pw)
-{
-  return(pw->cols-2);
-}
Index: sepbar.c
===================================================================
--- sepbar.c	(revision 044f19f7c86e3f63b353e7fff2865f139319a45a)
+++ sepbar.c	(revision 044f19f7c86e3f63b353e7fff2865f139319a45a)
@@ -0,0 +1,116 @@
+#include "owl.h"
+
+static void sepbar_redraw(owl_window *w, WINDOW *sepwin, void *user_data);
+
+void owl_sepbar_init(owl_window *w)
+{
+  g_signal_connect(w, "redraw", G_CALLBACK(sepbar_redraw), NULL);
+  /* TODO: handle dirtiness in the sepbar */
+  owl_window_dirty(w);
+}
+
+static void sepbar_redraw(owl_window *w, WINDOW *sepwin, void *user_data)
+{
+  const owl_messagelist *ml;
+  const owl_view *v;
+  int x, y, i;
+  const char *foo, *appendtosepbar;
+
+  ml=owl_global_get_msglist(&g);
+  v=owl_global_get_current_view(&g);
+
+  werase(sepwin);
+  wattron(sepwin, A_REVERSE);
+  if (owl_global_is_fancylines(&g)) {
+    whline(sepwin, ACS_HLINE, owl_global_get_cols(&g));
+  } else {
+    whline(sepwin, '-', owl_global_get_cols(&g));
+  }
+
+  if (owl_global_is_sepbar_disable(&g)) {
+    getyx(sepwin, y, x);
+    wmove(sepwin, y, owl_global_get_cols(&g)-1);
+    return;
+  }
+
+  wmove(sepwin, 0, 2);
+
+  if (owl_messagelist_get_size(ml) == 0)
+    waddstr(sepwin, " (-/-) ");
+  else
+    wprintw(sepwin, " (%i/%i/%i) ", owl_global_get_curmsg(&g) + 1,
+            owl_view_get_size(v),
+            owl_messagelist_get_size(ml));
+
+  foo=owl_view_get_filtname(v);
+  if (strcmp(foo, owl_global_get_view_home(&g)))
+      wattroff(sepwin, A_REVERSE);
+  wprintw(sepwin, " %s ", owl_view_get_filtname(v));
+  if (strcmp(foo, owl_global_get_view_home(&g)))
+      wattron(sepwin, A_REVERSE);
+
+  if (owl_mainwin_is_curmsg_truncated(owl_global_get_mainwin(&g))) {
+    getyx(sepwin, y, x);
+    wmove(sepwin, y, x+2);
+    wattron(sepwin, A_BOLD);
+    waddstr(sepwin, " <truncated> ");
+    wattroff(sepwin, A_BOLD);
+  }
+
+  i=owl_mainwin_get_last_msg(owl_global_get_mainwin(&g));
+  if ((i != -1) &&
+      (i < owl_view_get_size(v)-1)) {
+    getyx(sepwin, y, x);
+    wmove(sepwin, y, x+2);
+    wattron(sepwin, A_BOLD);
+    waddstr(sepwin, " <more> ");
+    wattroff(sepwin, A_BOLD);
+  }
+
+  if (owl_global_get_rightshift(&g)>0) {
+    getyx(sepwin, y, x);
+    wmove(sepwin, y, x+2);
+    wprintw(sepwin, " right: %i ", owl_global_get_rightshift(&g));
+  }
+
+  if (owl_global_is_zaway(&g) || owl_global_is_aaway(&g)) {
+    getyx(sepwin, y, x);
+    wmove(sepwin, y, x+2);
+    wattron(sepwin, A_BOLD);
+    wattroff(sepwin, A_REVERSE);
+    if (owl_global_is_zaway(&g) && owl_global_is_aaway(&g)) {
+      waddstr(sepwin, " AWAY ");
+    } else if (owl_global_is_zaway(&g)) {
+      waddstr(sepwin, " Z-AWAY ");
+    } else if (owl_global_is_aaway(&g)) {
+      waddstr(sepwin, " A-AWAY ");
+    }
+    wattron(sepwin, A_REVERSE);
+    wattroff(sepwin, A_BOLD);
+  }
+
+  if (owl_global_get_curmsg_vert_offset(&g)) {
+    getyx(sepwin, y, x);
+    wmove(sepwin, y, x+2);
+    wattron(sepwin, A_BOLD);
+    wattroff(sepwin, A_REVERSE);
+    waddstr(sepwin, " SCROLL ");
+    wattron(sepwin, A_REVERSE);
+    wattroff(sepwin, A_BOLD);
+  }
+
+  appendtosepbar = owl_global_get_appendtosepbar(&g);
+  if (appendtosepbar && *appendtosepbar) {
+    getyx(sepwin, y, x);
+    wmove(sepwin, y, x+2);
+    waddstr(sepwin, " ");
+    waddstr(sepwin, owl_global_get_appendtosepbar(&g));
+    waddstr(sepwin, " ");
+  }
+
+  getyx(sepwin, y, x);
+  wmove(sepwin, y, owl_global_get_cols(&g)-1);
+    
+  wattroff(sepwin, A_BOLD);
+  wattroff(sepwin, A_REVERSE);
+}
Index: stubgen.pl
===================================================================
--- stubgen.pl	(revision d7cc50b9bac64c7e71cb55c8686076c33f1f07dd)
+++ stubgen.pl	(revision ea7daa88a058dbbe1dfd9aa2f138f80d030b2f9c)
@@ -12,21 +12,37 @@
     my $altvarname = $2;
     $altvarname = $3 if ($3);
+    my $detailname = $altvarname;
+    $detailname =~ s/[^a-zA-Z0-9]/-/g;
+    $detailname =~ s/^[^a-zA-Z]+//;
     if ($vartype =~ /^BOOL/) {
-	print "void owl_global_set_${altvarname}_on(owl_global *g) {\n";
-	print "  owl_variable_set_bool_on(&g->vars, \"$varname\");\n}\n";
-	print "void owl_global_set_${altvarname}_off(owl_global *g) {\n";
-	print "  owl_variable_set_bool_off(&g->vars, \"$varname\");\n}\n";
-	print "int owl_global_is_$altvarname(const owl_global *g) {\n";
-	print "  return owl_variable_get_bool(&g->vars, \"$varname\");\n}\n";
+        print <<EOT;
+void owl_global_set_${altvarname}_on(owl_global *g) {
+  owl_variable_set_bool_on(&g->vars, "$altvarname");
+}
+void owl_global_set_${altvarname}_off(owl_global *g) {
+  owl_variable_set_bool_off(&g->vars, "$altvarname");
+}
+int owl_global_is_$altvarname(const owl_global *g) {
+  return owl_variable_get_bool(&g->vars, "$varname");
+}
+EOT
     } elsif ($vartype =~ /^PATH/ or $vartype =~ /^STRING/) {
-	print "void owl_global_set_$altvarname(owl_global *g, const char *text) {\n";
-	print "  owl_variable_set_string(&g->vars, \"$varname\", text);\n}\n";
-	print "const char *owl_global_get_$altvarname(const owl_global *g) {\n";
-	print "  return owl_variable_get_string(&g->vars, \"$varname\");\n}\n";
+        print <<EOT;
+void owl_global_set_${altvarname}(owl_global *g, const char *text) {
+  owl_variable_set_string(&g->vars, "$altvarname", text);
+}
+const char *owl_global_get_$altvarname(const owl_global *g) {
+  return owl_variable_get_string(&g->vars, "$varname");
+}
+EOT
     } elsif ($vartype =~ /^INT/ or $vartype =~ /^ENUM/) {
-	print "void owl_global_set_$altvarname(owl_global *g, int n) {\n";
-	print "  owl_variable_set_int(&g->vars, \"$varname\", n);\n}\n";
-	print "int owl_global_get_$altvarname(const owl_global *g) {\n";
-	print "  return owl_variable_get_int(&g->vars, \"$varname\");\n}\n";
+        print <<EOT;
+void owl_global_set_${altvarname}(owl_global *g, int n) {
+  owl_variable_set_int(&g->vars, "$altvarname", n);
+}
+int owl_global_get_$altvarname(const owl_global *g) {
+  return owl_variable_get_int(&g->vars, "$varname");
+}
+EOT
     } 
     }
Index: tester.c
===================================================================
--- tester.c	(revision 95414bfd3960e215dd54e6916a12f56abbf0c820)
+++ tester.c	(revision 95414bfd3960e215dd54e6916a12f56abbf0c820)
@@ -105,5 +105,4 @@
   numfailures += owl_variable_regtest();
   numfailures += owl_filter_regtest();
-  numfailures += owl_obarray_regtest();
   numfailures += owl_editwin_regtest();
   if (numfailures) {
@@ -368,33 +367,4 @@
 }
 
-
-int owl_obarray_regtest(void) {
-  int numfailed = 0;
-  const char *p,*p2;
-
-  owl_obarray oa;
-  owl_obarray_init(&oa);
-
-  printf("# BEGIN testing owl_obarray\n");
-
-  p = owl_obarray_insert(&oa, "test");
-  FAIL_UNLESS("returned string is equal", p && !strcmp(p, "test"));
-  p2 = owl_obarray_insert(&oa, "test");
-  FAIL_UNLESS("returned string is equal", p2 && !strcmp(p2, "test"));
-  FAIL_UNLESS("returned the same string", p2 && p == p2);
-
-  p = owl_obarray_insert(&oa, "test2");
-  FAIL_UNLESS("returned string is equal", p && !strcmp(p, "test2"));
-  p2 = owl_obarray_find(&oa, "test2");
-  FAIL_UNLESS("returned the same string", p2 && !strcmp(p2, "test2"));
-
-  p = owl_obarray_find(&oa, "nothere");
-  FAIL_UNLESS("Didn't find a string that isn't there", p == NULL);
-
-  printf("# END testing owl_obarray (%d failures)\n", numfailed);
-
-  return numfailed;
-}
-
 int owl_editwin_regtest(void) {
   int numfailed = 0;
Index: util.c
===================================================================
--- util.c	(revision 9a7b4f23cba7fc71c4e918b5cb8d5ca6789924e3)
+++ util.c	(revision c1f1e1e3f61fcf6b7a60ce2c7a2656f31c6277c4)
@@ -8,117 +8,5 @@
 #include <sys/types.h>
 
-void sepbar(const char *in)
-{
-  WINDOW *sepwin;
-  const owl_messagelist *ml;
-  const owl_view *v;
-  int x, y, i;
-  const char *foo, *appendtosepbar;
-
-  sepwin=owl_global_get_curs_sepwin(&g);
-  ml=owl_global_get_msglist(&g);
-  v=owl_global_get_current_view(&g);
-
-  werase(sepwin);
-  wattron(sepwin, A_REVERSE);
-  if (owl_global_is_fancylines(&g)) {
-    whline(sepwin, ACS_HLINE, owl_global_get_cols(&g));
-  } else {
-    whline(sepwin, '-', owl_global_get_cols(&g));
-  }
-
-  if (owl_global_is_sepbar_disable(&g)) {
-    getyx(sepwin, y, x);
-    wmove(sepwin, y, owl_global_get_cols(&g)-1);
-    return;
-  }
-
-  wmove(sepwin, 0, 2);
-
-  if (owl_messagelist_get_size(ml) == 0)
-    waddstr(sepwin, " (-/-) ");
-  else
-    wprintw(sepwin, " (%i/%i/%i) ", owl_global_get_curmsg(&g) + 1,
-            owl_view_get_size(v),
-            owl_messagelist_get_size(ml));
-
-  foo=owl_view_get_filtname(v);
-  if (strcmp(foo, owl_global_get_view_home(&g)))
-      wattroff(sepwin, A_REVERSE);
-  wprintw(sepwin, " %s ", owl_view_get_filtname(v));
-  if (strcmp(foo, owl_global_get_view_home(&g)))
-      wattron(sepwin, A_REVERSE);
-
-  if (owl_mainwin_is_curmsg_truncated(owl_global_get_mainwin(&g))) {
-    getyx(sepwin, y, x);
-    wmove(sepwin, y, x+2);
-    wattron(sepwin, A_BOLD);
-    waddstr(sepwin, " <truncated> ");
-    wattroff(sepwin, A_BOLD);
-  }
-
-  i=owl_mainwin_get_last_msg(owl_global_get_mainwin(&g));
-  if ((i != -1) &&
-      (i < owl_view_get_size(v)-1)) {
-    getyx(sepwin, y, x);
-    wmove(sepwin, y, x+2);
-    wattron(sepwin, A_BOLD);
-    waddstr(sepwin, " <more> ");
-    wattroff(sepwin, A_BOLD);
-  }
-
-  if (owl_global_get_rightshift(&g)>0) {
-    getyx(sepwin, y, x);
-    wmove(sepwin, y, x+2);
-    wprintw(sepwin, " right: %i ", owl_global_get_rightshift(&g));
-  }
-
-  if (owl_global_is_zaway(&g) || owl_global_is_aaway(&g)) {
-    getyx(sepwin, y, x);
-    wmove(sepwin, y, x+2);
-    wattron(sepwin, A_BOLD);
-    wattroff(sepwin, A_REVERSE);
-    if (owl_global_is_zaway(&g) && owl_global_is_aaway(&g)) {
-      waddstr(sepwin, " AWAY ");
-    } else if (owl_global_is_zaway(&g)) {
-      waddstr(sepwin, " Z-AWAY ");
-    } else if (owl_global_is_aaway(&g)) {
-      waddstr(sepwin, " A-AWAY ");
-    }
-    wattron(sepwin, A_REVERSE);
-    wattroff(sepwin, A_BOLD);
-  }
-
-  if (owl_global_get_curmsg_vert_offset(&g)) {
-    getyx(sepwin, y, x);
-    wmove(sepwin, y, x+2);
-    wattron(sepwin, A_BOLD);
-    wattroff(sepwin, A_REVERSE);
-    waddstr(sepwin, " SCROLL ");
-    wattron(sepwin, A_REVERSE);
-    wattroff(sepwin, A_BOLD);
-  }
-  
-  if (in) {
-    getyx(sepwin, y, x);
-    wmove(sepwin, y, x+2);
-    waddstr(sepwin, in);
-  }
-
-  appendtosepbar = owl_global_get_appendtosepbar(&g);
-  if (appendtosepbar && *appendtosepbar) {
-    getyx(sepwin, y, x);
-    wmove(sepwin, y, x+2);
-    waddstr(sepwin, " ");
-    waddstr(sepwin, owl_global_get_appendtosepbar(&g));
-    waddstr(sepwin, " ");
-  }
-
-  getyx(sepwin, y, x);
-  wmove(sepwin, y, owl_global_get_cols(&g)-1);
-    
-  wattroff(sepwin, A_BOLD);
-  wattroff(sepwin, A_REVERSE);
-}
+#include <glib-object.h>
 
 char **atokenize(const char *buffer, const char *sep, int *i)
@@ -786,2 +674,77 @@
   return buf;
 }
+
+gulong owl_dirty_window_on_signal(owl_window *w, gpointer sender, const gchar *detailed_signal)
+{
+  return owl_signal_connect_object(sender, detailed_signal, G_CALLBACK(owl_window_dirty), w, G_CONNECT_SWAPPED);
+}
+
+typedef struct { /*noproto*/
+  GObject  *sender;
+  gulong    signal_id;
+} SignalData;
+
+static void _closure_invalidated(gpointer data, GClosure *closure);
+
+/*
+ * GObject's g_signal_connect_object has a documented bug. This function is
+ * identical except it does not leak the signal handler.
+ */
+gulong owl_signal_connect_object(gpointer sender, const gchar *detailed_signal, GCallback c_handler, gpointer receiver, GConnectFlags connect_flags)
+{
+  g_return_val_if_fail (G_TYPE_CHECK_INSTANCE (sender), 0);
+  g_return_val_if_fail (detailed_signal != NULL, 0);
+  g_return_val_if_fail (c_handler != NULL, 0);
+
+  if (receiver) {
+    SignalData *sdata;
+    GClosure *closure;
+    gulong signal_id;
+
+    g_return_val_if_fail (G_IS_OBJECT (receiver), 0);
+
+    closure = ((connect_flags & G_CONNECT_SWAPPED) ? g_cclosure_new_object_swap : g_cclosure_new_object) (c_handler, receiver);
+    signal_id = g_signal_connect_closure (sender, detailed_signal, closure, connect_flags & G_CONNECT_AFTER);
+
+    /* Register the missing hooks */
+    sdata = g_slice_new0(SignalData);
+    sdata->sender = sender;
+    sdata->signal_id = signal_id;
+
+    g_closure_add_invalidate_notifier(closure, sdata, _closure_invalidated);
+
+    return signal_id;
+  } else {
+    return g_signal_connect_data(sender, detailed_signal, c_handler, NULL, NULL, connect_flags);
+  }
+}
+
+/*
+ * There are three ways the signal could come to an end:
+ * 
+ * 1. The user explicitly disconnects it with the returned signal_id.
+ *    - In that case, the disconnection unref's the closure, causing it
+ *      to first be invalidated. The handler's already disconnected, so
+ *      we have no work to do.
+ * 2. The sender gets destroyed.
+ *    - GObject will disconnect each signal which then goes into the above
+ *      case. Our handler does no work.
+ * 3. The receiver gets destroyed.
+ *    - The GClosure was created by g_cclosure_new_object_{,swap} which gets
+ *      invalidated when the receiver is destroyed. We then follow through case 1
+ *      again, but *this* time, the handler has not been disconnected. We then
+ *      clean up ourselves.
+ *
+ * We can't actually hook into this process earlier with weakrefs as GObject
+ * will, on object dispose, first disconnect signals, then invalidate closures,
+ * and notify weakrefs last.
+ */
+static void _closure_invalidated(gpointer data, GClosure *closure)
+{
+  SignalData *sdata = data;
+  if (g_signal_handler_is_connected(sdata->sender, sdata->signal_id)) {
+    g_signal_handler_disconnect(sdata->sender, sdata->signal_id);
+  }
+  g_slice_free(SignalData, sdata);
+}
+
Index: variable.c
===================================================================
--- variable.c	(revision 26ad412433e18b39230531a2a518a03bffc1d3d4)
+++ variable.c	(revision 26ad412433e18b39230531a2a518a03bffc1d3d4)
@@ -110,5 +110,5 @@
 
   OWLVAR_ENUM( "loggingdirection" /* %OwlVarStub */, OWL_LOGGING_DIRECTION_BOTH,
-	       "specifices which kind of messages should be logged",
+	       "specifies which kind of messages should be logged",
 	       "Can be one of 'both', 'in', or 'out'.  If 'in' is\n"
 	       "selected, only incoming messages are logged, if 'out'\n"
@@ -138,5 +138,5 @@
 		    "location of users in your .anyone file.  If a user is present\n"
 		    "but sent no login message, or a user is not present that sent no\n"
-		    "logout message, a pseudo login or logout message wil be created\n",
+		    "logout message, a pseudo login or logout message will be created\n",
 		    NULL, owl_variable_pseudologins_set, NULL),
 
@@ -151,5 +151,5 @@
 
 		 "If non empty, any messages matching the given filter will be logged.\n"
-		 "This is a completely separate mechanisim from the other logging\n"
+		 "This is a completely separate mechanism from the other logging\n"
 		 "variables like logging, classlogging, loglogins, loggingdirection,\n"
 		 "etc.  If you want this variable to control all logging, make sure\n"
@@ -199,5 +199,5 @@
   OWLVAR_PATH( "newmsgproc" /* %OwlVarStub:newmsgproc */, NULL,
 	       "name of a program to run when new messages are present",
-	       "The named program will be run when owl recevies new.\n"
+	       "The named program will be run when owl receives new\n"
 	       "messages.  It will not be run again until the first\n"
 	       "instance exits"),
@@ -214,5 +214,5 @@
 		 "Called every time you start a zephyrgram without an\n"
 		 "explicit zsig.  The default setting implements the policy\n"
-		 "descripted in the documentation for the 'zsig' variable.\n"),
+		 "described in the documentation for the 'zsig' variable.\n"),
 
   OWLVAR_STRING( "zsig" /* %OwlVarStub */, "",
@@ -298,5 +298,5 @@
 	      "number of seconds after AIM login to ignore login messages",
 	      "This specifies the number of seconds to wait after an\n"
-	      "AIM login before allowing the recipt of AIM login notifications.\n"
+	      "AIM login before allowing the receipt of AIM login notifications.\n"
 	      "By default this is set to 15.  If you would like to view login\n"
 	      "notifications of buddies as soon as you login, set it to 0 instead."),
@@ -401,5 +401,5 @@
   int rv;
   rv = owl_variable_int_set_default(v, newval);
-  if (0 == rv) owl_global_set_relayout_pending(&g);
+  if (0 == rv) owl_mainpanel_layout_contents(&g.mainpanel);
   return(rv);
 }
Index: viewwin.c
===================================================================
--- viewwin.c	(revision fe4c786091ae4f138f1edc26a13b2b8d0b3a034d)
+++ viewwin.c	(revision 0b9e6070c08d1acf0e1258b9938f43062c01e491)
@@ -4,8 +4,10 @@
 #define BOTTOM_OFFSET 1
 
+static void owl_viewwin_redraw(owl_window *w, WINDOW *curswin, void *user_data);
+
 /* initialize the viewwin e.  'win' is an already initialzed curses
  * window that will be used by viewwin
  */
-void owl_viewwin_init_text(owl_viewwin *v, WINDOW *win, int winlines, int wincols, const char *text)
+void owl_viewwin_init_text(owl_viewwin *v, owl_window *win, const char *text)
 {
   owl_fmtext_init_null(&(v->fmtext));
@@ -19,8 +21,7 @@
   v->topline=0;
   v->rightshift=0;
-  v->winlines=winlines;
-  v->wincols=wincols;
-  v->curswin=win;
   v->onclose_hook = NULL;
+
+  owl_viewwin_set_window(v, win);
 }
 
@@ -28,4 +29,5 @@
     owl_fmtext_append_normal(&(v->fmtext), text);
     v->textlines=owl_fmtext_num_lines(&(v->fmtext));  
+    owl_window_dirty(v->window);
 }
 
@@ -33,5 +35,5 @@
  * window that will be used by viewwin
  */
-void owl_viewwin_init_fmtext(owl_viewwin *v, WINDOW *win, int winlines, int wincols, const owl_fmtext *fmtext)
+void owl_viewwin_init_fmtext(owl_viewwin *v, owl_window *win, const owl_fmtext *fmtext)
 {
   char *text;
@@ -46,14 +48,19 @@
   v->topline=0;
   v->rightshift=0;
-  v->winlines=winlines;
-  v->wincols=wincols;
-  v->curswin=win;
+
+  owl_viewwin_set_window(v, win);
 }
 
-void owl_viewwin_set_curswin(owl_viewwin *v, WINDOW *w, int winlines, int wincols)
+void owl_viewwin_set_window(owl_viewwin *v, owl_window *w)
 {
-  v->curswin=w;
-  v->winlines=winlines;
-  v->wincols=wincols;
+  if (v->window) {
+    g_signal_handler_disconnect(v->window, v->sig_redraw_id);
+    g_object_unref(v->window);
+  }
+  v->window = w;
+  if (w) {
+    g_object_ref(v->window);
+    v->sig_redraw_id = g_signal_connect(w, "redraw", G_CALLBACK(owl_viewwin_redraw), v);
+  }
 }
 
@@ -64,32 +71,32 @@
 
 /* regenerate text on the curses window. */
-void owl_viewwin_redisplay(owl_viewwin *v)
+static void owl_viewwin_redraw(owl_window *w, WINDOW *curswin, void *user_data)
 {
   owl_fmtext fm1, fm2;
+  owl_viewwin *v = user_data;
+  int winlines, wincols;
 
-  /* avoid segfault when screen too small to create curswin */
-  if (v->curswin == NULL)
-    return;
+  owl_window_get_position(w, &winlines, &wincols, 0, 0);
   
-  werase(v->curswin);
-  wmove(v->curswin, 0, 0);
+  werase(curswin);
+  wmove(curswin, 0, 0);
 
   owl_fmtext_init_null(&fm1);
   owl_fmtext_init_null(&fm2);
   
-  owl_fmtext_truncate_lines(&(v->fmtext), v->topline, v->winlines-BOTTOM_OFFSET, &fm1);
-  owl_fmtext_truncate_cols(&fm1, v->rightshift, v->wincols-1+v->rightshift, &fm2);
+  owl_fmtext_truncate_lines(&(v->fmtext), v->topline, winlines-BOTTOM_OFFSET, &fm1);
+  owl_fmtext_truncate_cols(&fm1, v->rightshift, wincols-1+v->rightshift, &fm2);
 
-  owl_fmtext_curs_waddstr_without_search(&fm2, v->curswin);
+  owl_fmtext_curs_waddstr_without_search(&fm2, curswin);
 
   /* print the message at the bottom */
-  wmove(v->curswin, v->winlines-1, 0);
-  wattrset(v->curswin, A_REVERSE);
-  if (v->textlines - v->topline > v->winlines-BOTTOM_OFFSET) {
-    waddstr(v->curswin, "--More-- (Space to see more, 'q' to quit)");
+  wmove(curswin, winlines-1, 0);
+  wattrset(curswin, A_REVERSE);
+  if (v->textlines - v->topline > winlines-BOTTOM_OFFSET) {
+    waddstr(curswin, "--More-- (Space to see more, 'q' to quit)");
   } else {
-    waddstr(v->curswin, "--End-- (Press 'q' to quit)");
+    waddstr(curswin, "--End-- (Press 'q' to quit)");
   }
-  wattroff(v->curswin, A_REVERSE);
+  wattroff(curswin, A_REVERSE);
 
   owl_fmtext_cleanup(&fm1);
@@ -99,22 +106,31 @@
 void owl_viewwin_pagedown(owl_viewwin *v)
 {
-  v->topline+=v->winlines - BOTTOM_OFFSET;
-  if ( (v->topline+v->winlines-BOTTOM_OFFSET) > v->textlines) {
-    v->topline = v->textlines - v->winlines + BOTTOM_OFFSET;
+  int winlines;
+  owl_window_get_position(v->window, &winlines, 0, 0, 0);
+  v->topline+=winlines - BOTTOM_OFFSET;
+  if ( (v->topline+winlines-BOTTOM_OFFSET) > v->textlines) {
+    v->topline = v->textlines - winlines + BOTTOM_OFFSET;
   }
+  owl_window_dirty(v->window);
 }
 
 void owl_viewwin_linedown(owl_viewwin *v)
 {
+  int winlines;
+  owl_window_get_position(v->window, &winlines, 0, 0, 0);
   v->topline++;
-  if ( (v->topline+v->winlines-BOTTOM_OFFSET) > v->textlines) {
-    v->topline = v->textlines - v->winlines + BOTTOM_OFFSET;
+  if ( (v->topline+winlines-BOTTOM_OFFSET) > v->textlines) {
+    v->topline = v->textlines - winlines + BOTTOM_OFFSET;
   }
+  owl_window_dirty(v->window);
 }
 
 void owl_viewwin_pageup(owl_viewwin *v)
 {
-  v->topline-=v->winlines;
+  int winlines;
+  owl_window_get_position(v->window, &winlines, 0, 0, 0);
+  v->topline-=winlines;
   if (v->topline<0) v->topline=0;
+  owl_window_dirty(v->window);
 }
 
@@ -123,4 +139,5 @@
   v->topline--;
   if (v->topline<0) v->topline=0;
+  owl_window_dirty(v->window);
 }
 
@@ -128,4 +145,5 @@
 {
   v->rightshift+=n;
+  owl_window_dirty(v->window);
 }
 
@@ -134,4 +152,5 @@
   v->rightshift-=n;
   if (v->rightshift<0) v->rightshift=0;
+  owl_window_dirty(v->window);
 }
 
@@ -140,13 +159,18 @@
   v->topline=0;
   v->rightshift=0;
+  owl_window_dirty(v->window);
 }
 
 void owl_viewwin_bottom(owl_viewwin *v)
 {
-  v->topline = v->textlines - v->winlines + BOTTOM_OFFSET;
+  int winlines;
+  owl_window_get_position(v->window, &winlines, 0, 0, 0);
+  v->topline = v->textlines - winlines + BOTTOM_OFFSET;
+  owl_window_dirty(v->window);
 }
 
 void owl_viewwin_cleanup(owl_viewwin *v)
 {
+  owl_viewwin_set_window(v, NULL);
   if (v->onclose_hook) {
     v->onclose_hook(v, v->onclose_hook_data);
